package net.sf.tacos.binding;

import org.apache.hivemind.Location;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.binding.AbstractBindingFactory;
import org.apache.tapestry.services.AbsoluteURLBuilder;

/**
 * Implementation of {@link org.apache.tapestry.binding.BindingFactory} that constructs
 * {@link net.sf.tacos.binding.AbsoluteAssetBinding} instances.
 * 
 * @author Andreas Andreou
 * @since 4.1
 */
public class AbsoluteAssetBindingFactory extends AbstractBindingFactory {
    
    private AbsoluteURLBuilder absoluteURLBuilder;

    public AbsoluteURLBuilder getAbsoluteURLBuilder() {
        return absoluteURLBuilder;
    }

    public void setAbsoluteURLBuilder(AbsoluteURLBuilder absoluteURLBuilder) {
        this.absoluteURLBuilder = absoluteURLBuilder;
    }
	
    public IBinding createBinding(IComponent root, String description,
                    String expression, Location location) {
            return new AbsoluteAssetBinding(description, getValueConverter(), absoluteURLBuilder,
                    location, root, expression);
    }

}
