package net.sf.tacos.binding;

import org.apache.hivemind.Location;
import org.apache.tapestry.binding.AbstractBinding;
import org.apache.tapestry.coerce.ValueConverter;

/**
 * Implementation of {@link org.apache.tapestry.IBinding} that stores a static
 * (invariant) string as the value. This string represents a name of an javascript function.
 * 
 * @author Igor Drobiazko
 * @since 4.1
 */
public class CallbackFunctionBinding extends AbstractBinding implements ICallbackFunction{
	
	protected CallbackFunctionBinding(String description, ValueConverter valueConverter, Location location, String value) {
		super(value, valueConverter, location);
	}
	
	/**
	 * {@inheritDoc}
	 */
	public Object getObject() {
		return getFunctionName();
	}
	
	/**
	 * {@inheritDoc}
	 */
	public String getFunctionName(){
		return getDescription();
	}
	
	/**
	 * Returns the string representation of the object.
	 */
    public String toString(){
        return "CallbackFunctionBinding[" + getFunctionName() + "]";
    }

}
