/*
 * TemplateBindingFactory.java
 *
 */ 

package net.sf.tacos.binding;

import org.apache.hivemind.Location;
import org.apache.tapestry.IBinding;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.binding.AbstractBindingFactory;
import org.apache.tapestry.binding.BindingFactory;

/**
 *
 * @author andyhot
 */
public class TemplateBindingFactory extends AbstractBindingFactory
{
    /**
     * Internal used BindingFactory
     */
    private BindingFactory nestedBindingFactory;

    /**
     * The BindingFactory for creating the inside variable IBinding.
     *
     * @param nestedBindingFactory Internal used BindingFactory
     */
    public void setNestedBindingFactory(BindingFactory nestedBindingFactory)
    {
        this.nestedBindingFactory = nestedBindingFactory;
    }

    /**
     * @see org.apache.tapestry.binding.BindingFactory#createBinding(org.apache.tapestry.IComponent, String, String, org.apache.hivemind.Location)
     */
    public IBinding createBinding(IComponent root, String bindingDescription, String path, Location location)
    {
        return new TemplateBinding(bindingDescription, location, getValueConverter(), root, path, nestedBindingFactory);
    }
}
