/*
 * Firebug.java
 */

package net.sf.tacos.components;

import org.apache.tapestry.AbstractComponent;
import org.apache.tapestry.IAsset;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;

/**
 * Adds Firebug-lite into current page.
 * @author andyhot
 */
public abstract class Firebug extends AbstractComponent
{    
    public abstract boolean isDisabled();

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {
        if (!cycle.isRewinding() && !isDisabled())
        {         
            cycle.getResponseBuilder().addExternalScript(this, 
                    getScriptAsset().getResourceLocation());
        }
    }  
    
    /** Injected asset. */
    public abstract IAsset getScriptAsset();     
}
