/*
 * AbstractContainerWidget.java
 *
 * Created on February 3, 2007, 7:01 AM
 */

package net.sf.tacos.components.dojo;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.dojo.AbstractWidget;

/**
 * A widget that can also be a container.
 * 
 * @author andyhot
 */
public abstract class GenericWidget extends AbstractWidget{
    
    public abstract boolean getIsContainer();
    public abstract boolean getNeverDestroy();
    
    /**
     * If this component is a container.
     */
    public boolean getContainerState()
    {
        return getIsContainer();
    }
    
    public void renderComponent(IMarkupWriter writer, IRequestCycle cycle)
    {
        if(!cycle.isRewinding() && !getNeverDestroy()) {            
            if (!cycle.getResponseBuilder().isDynamic() 
                    || cycle.getResponseBuilder().explicitlyContains(this)) {                
                setDestroy(false);
            } else
                setDestroy(true);
        }
        
        // don't render if not part of update response and we're not containers
        if (!getContainerState()) {            
            if (cycle.getResponseBuilder().isDynamic()
                    && (!cycle.getResponseBuilder().explicitlyContains(this) 
                            && !cycle.getResponseBuilder().contains(this))) {
                return;
            }
        }
        
        renderWidget(writer, cycle);
    }    
    
    
}
