package net.sf.tacos.components.dojo;

import org.apache.tapestry.dojo.IWidget;

/**
 * Represents a <a href="http://dojotoolkit.org">dojo</a> widget that contains children widgets.
 * A contained widget can use the method {@link #addChild(IWidget)} to add itself to its container.
 * During the execution of the container's script template the childs are added by calling
 * <code>dojo.widget.DomWidget.addChild(Widget)</code>
 * 
 * @author idrobiazk
 *
 */
public interface IDojoContainer {
	
	/**
	 * Adds a child {@link IWidget} to a container.
	 * @param widget child to add
	 */
	public void addChild(IWidget widget);
}
