package net.sf.tacos.components.scriptaculous;

import java.util.HashMap;
import java.util.Map;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.IScript;
import org.apache.tapestry.TapestryUtils;
import org.apache.tapestry.components.Block;
import org.apache.tapestry.json.JSONObject;

/**
 * Creates a diashow of provided {@link Block}s.
 * 
 * @author Igor Drobiazko
 *
 */
public abstract class Glider extends BaseComponent {
	
	/**
     * {@inheritDoc}
     */
	protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) {
		writer.begin("div");
        renderIdAttribute(writer, cycle);
        renderInformalParameters(writer, cycle);
        super.renderComponent(writer, cycle);
        
        writer.end();
        
        JSONObject json = new JSONObject();
        json.put("duration", getDuration());
        
        Map parms = new HashMap();
        parms.put("props", json.toString());
        parms.put("component", this);
        
        getScript().execute(this, cycle, TapestryUtils.getPageRenderSupport(cycle, this), parms);
	}
    
    public String getSectionId(int index){
    	return "section"+(++index);
    }

	public abstract double getDuration();
	
    /** Injected {@link IScript}. */
    public abstract IScript getScript();

}
