package net.sf.tacos.components.timeline;

import java.util.Collection;
import java.util.Iterator;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.html.Shell;
import org.apache.tapestry.json.JSONObject;

/**
 * Timeline component, based on http://simile.mit.edu/timeline/
 *
 * @author Andreas Andreou, amplafi.com
 */
public abstract class Timeline extends BaseComponent {

    public abstract Collection getEvents();

    public abstract String getEventsUrl();

    protected void prepareForRender(IRequestCycle cycle)
    {
        super.prepareForRender(cycle);

        if (!cycle.isRewinding()) {
            Shell.get(cycle).includeAdditionalContent(
                "<script src=\"http://simile.mit.edu/timeline/api/timeline-api.js\" type=\"text/javascript\"></script>");
        }
    }

    public String getEventsJson()
    {
        JSONObject json = new JSONObject();
        for (Iterator iterator = getEvents().iterator(); iterator.hasNext();)
        {
            TimelineEvent evt = (TimelineEvent) iterator.next();
            evt.appendTo(json);
        }
        return json.toString(2);
    }
}
