package net.sf.tacos.model;

import java.util.Collection;

/**
 * @author phraktle
 */
public interface ITreeContentProvider extends IContentProvider {

    /**
     * Returns all child elements of a parent. The returned collection is not
     * modified by the viewer.
     * 
     * @param parentElement
     * @return Collection of child nodes (never null)
     */
    public Collection getChildren(Object parentElement);

    /**
     * @param parentElement
     * @return
     */
    public boolean hasChildren(Object parentElement);

    /**
     * Returns the parent of the given element, or <code>null</code> if the
     * the parent can't be determined. Revealing a specific element will not
     * work in this case.
     * 
     * @param childElement
     * @return parent or null
     */
    public Object getParent(Object childElement);
}