package net.sf.tacos.model;

import java.io.Serializable;

/**
 * Default IKeyProvider implementation that uses the object's identity hash.
 * This only works if the object instances are the same across requests (ie.
 * static).
 * 
 * @author phraktle
 */
public class IdentityKeyProvider implements IKeyProvider {

    /**
     * 
     * {@inheritDoc}
     */
    public Serializable getKey(Object value)
    {
        return new Integer(System.identityHashCode(value));
    }

}