/*******************************************************************************
 * Copyright (c) 2005 Gabriel Handford.
 * All rights reserved.
 *
 * Contributors:
 *    Gabriel Handford -
 *******************************************************************************/
package net.sf.tacos.services;

import java.util.List;

/**
 * This class describes a category that contains page names.
 *
 * @author Gabriel Handford
 */
public interface CategoryInfo {

    /**
     * Get the category name.
     * @return name
     */
    public String getName();

    /**
     * Get the default page.
     * @return The default page, or the first page, or null.
     */
    public String getDefaultPage();

    /**
     * Get the category pages.
     * @return pages
     */
    public List getPageNames();

    /**
     * Returns active image for category.
     * @return
     */
    public String getImage();
    
    /**
     * Returns the inactive image for category.
     * @return
     */
    public String getInactiveImage();
}
